
void _efl_input_pointer_action_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Pointer_Action act);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_action_set, EFL_FUNC_CALL(act), Efl_Pointer_Action act);

Efl_Pointer_Action _efl_input_pointer_action_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_action_get, Efl_Pointer_Action, 0);

Eina_Bool _efl_input_pointer_value_has_get(const Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Value key);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_input_pointer_value_has_get, Eina_Bool, 0, EFL_FUNC_CALL(key), Efl_Input_Value key);

Eina_Bool _efl_input_pointer_value_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Value key, double val);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV(efl_input_pointer_value_set, Eina_Bool, 0, EFL_FUNC_CALL(key, val), Efl_Input_Value key, double val);

double _efl_input_pointer_value_get(const Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Value key);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_input_pointer_value_get, double, 0, EFL_FUNC_CALL(key), Efl_Input_Value key);

void _efl_input_pointer_button_set(Eo *obj, Efl_Input_Pointer_Data *pd, int but);


static Eina_Error
__eolian_efl_input_pointer_button_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_button_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_button_set, EFL_FUNC_CALL(but), int but);

int _efl_input_pointer_button_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_button_get_reflect(const Eo *obj)
{
   int val = efl_input_pointer_button_get(obj);
   return eina_value_int_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_button_get, int, 0);

void _efl_input_pointer_button_pressed_set(Eo *obj, Efl_Input_Pointer_Data *pd, int button, Eina_Bool pressed);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_button_pressed_set, EFL_FUNC_CALL(button, pressed), int button, Eina_Bool pressed);

Eina_Bool _efl_input_pointer_button_pressed_get(const Eo *obj, Efl_Input_Pointer_Data *pd, int button);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODYV_CONST(efl_input_pointer_button_pressed_get, Eina_Bool, 0, EFL_FUNC_CALL(button), int button);

void _efl_input_pointer_position_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Position2D pos);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_position_set, EFL_FUNC_CALL(pos), Eina_Position2D pos);

Eina_Position2D _efl_input_pointer_position_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_position_get, Eina_Position2D, ((Eina_Position2D){0}));

void _efl_input_pointer_precise_position_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Vector2 pos);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_precise_position_set, EFL_FUNC_CALL(pos), Eina_Vector2 pos);

Eina_Vector2 _efl_input_pointer_precise_position_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_precise_position_get, Eina_Vector2, ((Eina_Vector2){0}));

void _efl_input_pointer_previous_position_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Position2D pos);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_previous_position_set, EFL_FUNC_CALL(pos), Eina_Position2D pos);

Eina_Position2D _efl_input_pointer_previous_position_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_previous_position_get, Eina_Position2D, ((Eina_Position2D){0}));

void _efl_input_pointer_touch_id_set(Eo *obj, Efl_Input_Pointer_Data *pd, int id);


static Eina_Error
__eolian_efl_input_pointer_touch_id_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_touch_id_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_touch_id_set, EFL_FUNC_CALL(id), int id);

int _efl_input_pointer_touch_id_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_touch_id_get_reflect(const Eo *obj)
{
   int val = efl_input_pointer_touch_id_get(obj);
   return eina_value_int_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_touch_id_get, int, 0);

void _efl_input_pointer_source_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Object *src);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_source_set, EFL_FUNC_CALL(src), Efl_Object *src);

Efl_Object *_efl_input_pointer_source_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_source_get, Efl_Object *, NULL);

void _efl_input_pointer_button_flags_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Pointer_Flags flags);

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_button_flags_set, EFL_FUNC_CALL(flags), Efl_Pointer_Flags flags);

Efl_Pointer_Flags _efl_input_pointer_button_flags_get(const Eo *obj, Efl_Input_Pointer_Data *pd);

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_button_flags_get, Efl_Pointer_Flags, 0);

void _efl_input_pointer_double_click_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Bool val);


static Eina_Error
__eolian_efl_input_pointer_double_click_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_double_click_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_double_click_set, EFL_FUNC_CALL(val), Eina_Bool val);

Eina_Bool _efl_input_pointer_double_click_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_double_click_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_input_pointer_double_click_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_double_click_get, Eina_Bool, 0);

void _efl_input_pointer_triple_click_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Bool val);


static Eina_Error
__eolian_efl_input_pointer_triple_click_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_triple_click_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_triple_click_set, EFL_FUNC_CALL(val), Eina_Bool val);

Eina_Bool _efl_input_pointer_triple_click_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_triple_click_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_input_pointer_triple_click_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_triple_click_get, Eina_Bool, 0);

void _efl_input_pointer_wheel_horizontal_set(Eo *obj, Efl_Input_Pointer_Data *pd, Eina_Bool horizontal);


static Eina_Error
__eolian_efl_input_pointer_wheel_horizontal_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   Eina_Bool cval;
   if (!eina_value_bool_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_wheel_horizontal_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_wheel_horizontal_set, EFL_FUNC_CALL(horizontal), Eina_Bool horizontal);

Eina_Bool _efl_input_pointer_wheel_horizontal_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_wheel_horizontal_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_input_pointer_wheel_horizontal_get(obj);
   return eina_value_bool_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_wheel_horizontal_get, Eina_Bool, EINA_FALSE /* false */);

void _efl_input_pointer_wheel_delta_set(Eo *obj, Efl_Input_Pointer_Data *pd, int dist);


static Eina_Error
__eolian_efl_input_pointer_wheel_delta_set_reflect(Eo *obj, Eina_Value val)
{
   Eina_Error r = 0;   int cval;
   if (!eina_value_int_convert(&val, &cval))
      {
         r = EINA_ERROR_VALUE_FAILED;
         goto end;
      }
   efl_input_pointer_wheel_delta_set(obj, cval);
 end:
   eina_value_flush(&val);
   return r;
}

EVAS_API EVAS_API_WEAK EFL_VOID_FUNC_BODYV(efl_input_pointer_wheel_delta_set, EFL_FUNC_CALL(dist), int dist);

int _efl_input_pointer_wheel_delta_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


static Eina_Value
__eolian_efl_input_pointer_wheel_delta_get_reflect(const Eo *obj)
{
   int val = efl_input_pointer_wheel_delta_get(obj);
   return eina_value_int_init(val);
}

EVAS_API EVAS_API_WEAK EFL_FUNC_BODY_CONST(efl_input_pointer_wheel_delta_get, int, 0);

Efl_Object *_efl_input_pointer_efl_object_constructor(Eo *obj, Efl_Input_Pointer_Data *pd);


void _efl_input_pointer_efl_object_destructor(Eo *obj, Efl_Input_Pointer_Data *pd);


void _efl_input_pointer_efl_input_event_reset(Eo *obj, Efl_Input_Pointer_Data *pd);


Efl_Duplicate *_efl_input_pointer_efl_duplicate_duplicate(const Eo *obj, Efl_Input_Pointer_Data *pd);


void _efl_input_pointer_efl_input_event_timestamp_set(Eo *obj, Efl_Input_Pointer_Data *pd, double ms);


double _efl_input_pointer_efl_input_event_timestamp_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


Eina_Bool _efl_input_pointer_efl_input_event_fake_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


void _efl_input_pointer_efl_input_event_event_flags_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Flags flags);


Efl_Input_Flags _efl_input_pointer_efl_input_event_event_flags_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


void _efl_input_pointer_efl_input_event_device_set(Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Device *dev);


Efl_Input_Device *_efl_input_pointer_efl_input_event_device_get(const Eo *obj, Efl_Input_Pointer_Data *pd);


Eina_Bool _efl_input_pointer_efl_input_state_modifier_enabled_get(const Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Modifier mod, const Efl_Input_Device *seat);


Eina_Bool _efl_input_pointer_efl_input_state_lock_enabled_get(const Eo *obj, Efl_Input_Pointer_Data *pd, Efl_Input_Lock lock, const Efl_Input_Device *seat);


static Eina_Bool
_efl_input_pointer_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_INPUT_POINTER_EXTRA_OPS
#define EFL_INPUT_POINTER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_input_pointer_action_set, _efl_input_pointer_action_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_action_get, _efl_input_pointer_action_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_value_has_get, _efl_input_pointer_value_has_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_value_set, _efl_input_pointer_value_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_value_get, _efl_input_pointer_value_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_set, _efl_input_pointer_button_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_get, _efl_input_pointer_button_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_pressed_set, _efl_input_pointer_button_pressed_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_pressed_get, _efl_input_pointer_button_pressed_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_position_set, _efl_input_pointer_position_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_position_get, _efl_input_pointer_position_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_precise_position_set, _efl_input_pointer_precise_position_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_precise_position_get, _efl_input_pointer_precise_position_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_previous_position_set, _efl_input_pointer_previous_position_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_previous_position_get, _efl_input_pointer_previous_position_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_touch_id_set, _efl_input_pointer_touch_id_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_touch_id_get, _efl_input_pointer_touch_id_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_source_set, _efl_input_pointer_source_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_source_get, _efl_input_pointer_source_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_flags_set, _efl_input_pointer_button_flags_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_button_flags_get, _efl_input_pointer_button_flags_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_double_click_set, _efl_input_pointer_double_click_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_double_click_get, _efl_input_pointer_double_click_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_triple_click_set, _efl_input_pointer_triple_click_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_triple_click_get, _efl_input_pointer_triple_click_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_wheel_horizontal_set, _efl_input_pointer_wheel_horizontal_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_wheel_horizontal_get, _efl_input_pointer_wheel_horizontal_get),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_wheel_delta_set, _efl_input_pointer_wheel_delta_set),
      EFL_OBJECT_OP_FUNC(efl_input_pointer_wheel_delta_get, _efl_input_pointer_wheel_delta_get),
      EFL_OBJECT_OP_FUNC(efl_constructor, _efl_input_pointer_efl_object_constructor),
      EFL_OBJECT_OP_FUNC(efl_destructor, _efl_input_pointer_efl_object_destructor),
      EFL_OBJECT_OP_FUNC(efl_input_reset, _efl_input_pointer_efl_input_event_reset),
      EFL_OBJECT_OP_FUNC(efl_duplicate, _efl_input_pointer_efl_duplicate_duplicate),
      EFL_OBJECT_OP_FUNC(efl_input_timestamp_set, _efl_input_pointer_efl_input_event_timestamp_set),
      EFL_OBJECT_OP_FUNC(efl_input_timestamp_get, _efl_input_pointer_efl_input_event_timestamp_get),
      EFL_OBJECT_OP_FUNC(efl_input_fake_get, _efl_input_pointer_efl_input_event_fake_get),
      EFL_OBJECT_OP_FUNC(efl_input_event_flags_set, _efl_input_pointer_efl_input_event_event_flags_set),
      EFL_OBJECT_OP_FUNC(efl_input_event_flags_get, _efl_input_pointer_efl_input_event_event_flags_get),
      EFL_OBJECT_OP_FUNC(efl_input_device_set, _efl_input_pointer_efl_input_event_device_set),
      EFL_OBJECT_OP_FUNC(efl_input_device_get, _efl_input_pointer_efl_input_event_device_get),
      EFL_OBJECT_OP_FUNC(efl_input_modifier_enabled_get, _efl_input_pointer_efl_input_state_modifier_enabled_get),
      EFL_OBJECT_OP_FUNC(efl_input_lock_enabled_get, _efl_input_pointer_efl_input_state_lock_enabled_get),
      EFL_INPUT_POINTER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"button", __eolian_efl_input_pointer_button_set_reflect, __eolian_efl_input_pointer_button_get_reflect},
      {"touch_id", __eolian_efl_input_pointer_touch_id_set_reflect, __eolian_efl_input_pointer_touch_id_get_reflect},
      {"double_click", __eolian_efl_input_pointer_double_click_set_reflect, __eolian_efl_input_pointer_double_click_get_reflect},
      {"triple_click", __eolian_efl_input_pointer_triple_click_set_reflect, __eolian_efl_input_pointer_triple_click_get_reflect},
      {"wheel_horizontal", __eolian_efl_input_pointer_wheel_horizontal_set_reflect, __eolian_efl_input_pointer_wheel_horizontal_get_reflect},
      {"wheel_delta", __eolian_efl_input_pointer_wheel_delta_set_reflect, __eolian_efl_input_pointer_wheel_delta_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_input_pointer_class_desc = {
   EO_VERSION,
   "Efl.Input.Pointer",
   EFL_CLASS_TYPE_REGULAR,
   sizeof(Efl_Input_Pointer_Data),
   _efl_input_pointer_class_initializer,
   NULL,
   _efl_input_pointer_class_destructor
};

EFL_DEFINE_CLASS(efl_input_pointer_class_get, &_efl_input_pointer_class_desc, EFL_OBJECT_CLASS, EFL_INPUT_EVENT_MIXIN, EFL_INPUT_STATE_INTERFACE, NULL);
